public class Pattern {

	Window parent;

	int nbBeats = 4;
	int[] notes = new int[nbBeats];
	int[] modulations = new int[nbBeats];
	int[] durations = new int[nbBeats];
	int nbParameters = 3;

	Pattern(Window p) {
		parent = p;
		loadDefault();
	}

	public void loadDefault() {
		for (int i = 0; i < nbBeats; i++) {
			notes[i] = 128;
			modulations[i] = 3;
			durations[i] = 10;
		}
	}

	public void updateAllPDValues() {
		for (int i = 0; i < nbBeats; i++) {
			parent.setValue(i * nbParameters + 0, notes[i]);
			parent.setValue(i * nbParameters + 1, modulations[i]);
			parent.setValue(i * nbParameters + 2, durations[i]);
		}
	}

	public void setValue(int mouseBeat, int param, int value) {
		if (param == 0) {
			notes[mouseBeat] = value;
		}
		if (param == 1) {
			modulations[mouseBeat] = value;
		}
		if (param == 2) {
			durations[mouseBeat] = value;
		}
	}

	public void display() {
		for (int i = 0; i < nbBeats; i++) {
			parent.noStroke();
			parent.fill(0x00, 0xAA, 0xFF, 0xAA);
			parent.rect((float) parent.width / nbBeats * i, (float) 0
					* parent.height / nbParameters, (float) parent.width
					/ nbBeats, (float) parent.height * ((float) notes[i] / 256)
					/ nbParameters);
			parent.rect((float) parent.width / nbBeats * i, (float) 1
					* parent.height / nbParameters, (float) parent.width
					/ nbBeats, (float) parent.height
					* ((float) modulations[i] / 256) / nbParameters);
			parent.rect((float) parent.width / nbBeats * i, (float) 2
					* parent.height / nbParameters, (float) parent.width
					/ nbBeats, (float) parent.height
					* ((float) durations[i] / 256) / nbParameters);
		}
	}

}
