import processing.core.*;
import oscP5.*;
import netP5.*;

public class Window extends PApplet {
	private static final long serialVersionUID = 1L;

	OscP5 oscP5;
	NetAddress myRemoteLocation;

	int beat = 0;// current beat
	int nbBeats = 4;// nb of beats in one bar
	float tempo = 100;// the tempo of the song

	Pattern pattern;

	public void setup() {
		size(200, 200);
		oscP5 = new OscP5(this, 12000);
		myRemoteLocation = new NetAddress("127.0.0.1", 12001);
		oscP5.plug(this, "setBeat", "/setBeat");
		setPDTempo();
		pattern = new Pattern(this);
		updateAllPDValues();
	}

	public void draw() {
		background(0);
		noStroke();
		fill(0xFF, 0xAA, 0x00, 0xAA);
		rect((float) width / nbBeats * beat, 0, (float) width / nbBeats, height);
		pattern.display();
	}

	public void mousePressed() {
		int mouseBeat = floor((float) mouseX / width * 4);
		int param = floor((float) mouseY / height * pattern.nbParameters);
		int value = floor((float) (mouseY
				% ((float) height / pattern.nbParameters)
				/ ((float) height / pattern.nbParameters) * 256));
		pattern.setValue(mouseBeat, param, value);
		updateAllPDValues();
	}

	public void keyPressed() {
		updateAllPDValues();
	}

	private void updateAllPDValues() {
		pattern.updateAllPDValues();
	}

	void setBeat(int beat) {
		this.beat = beat;
	}

	public void setValue(int address, int value) {
		OscMessage myOscMessage = new OscMessage("/setValue");
		myOscMessage.add((int) value);
		myOscMessage.add((int) address);
		oscP5.send(myOscMessage, myRemoteLocation);
	}

	public void setPDTempo() {
		OscMessage myOscMessage = new OscMessage("/setTempo");
		myOscMessage.add((float) tempo);
		oscP5.send(myOscMessage, myRemoteLocation);
	}

	public static void main(String args[]) {
		PApplet.main(new String[] { "Window" });
	}

}
