import java.util.Vector;
import processing.core.*;
import oscP5.*;
import netP5.*;

public class Window extends PApplet {
	private static final long serialVersionUID = 1L;

	OscP5 oscP5;
	NetAddress myRemoteLocation;

	public void setup() {
		oscP5 = new OscP5(this, 12000);
		myRemoteLocation = new NetAddress("127.0.0.1", 12001);
		oscP5.plug(this, "setBeat", "/setBeat");
		String[] tune = loadStrings(dataPath("tune.txt"));
		setTempo(Integer.parseInt(tune[0]));
		int[] defaultParams = parseBeat(tune[1]);
		for (int i = 0; i < defaultParams.length; i++) {// parameters
			int nbParameters = 13;// change this in case there are more
									// parameters
			for (int i2 = 0; i2 < 12; i2++) {// tracks
				setValue(i2, defaultParams[i], 0, 0, -nbParameters + i);
			}
		}
		for (int i = 2; i < tune.length; i++) {
			int[] beat = parseBeat(tune[i]);
			for (int i2 = 0; i2 < beat.length; i2++) {
				setValue(floor(i2 / 3), beat[i2], 0, i, i2 % 3);
			}
		}
	}

	private int[] parseBeat(String beat) {
		Vector<Integer> result = new Vector<Integer>();
		for (int i2 = 0; i2 < beat.length(); i2++) {
			if (beat.charAt(i2) == ',') {
				for (int i3 = i2 + 1; i3 < beat.length(); i3++) {
					if (beat.charAt(i3) == ',' || beat.charAt(i3) == ';') {
						result
								.add(Integer.parseInt(beat
										.substring(i2 + 1, i3)));
						i3 = beat.length();
					}
				}
			}
		}
		int[] result2 = new int[result.size()];
		for (int i = 0; i < result.size(); i++) {
			result2[i] = result.get(i);
		}
		return result2;
	}

	public void setValue(int track, int value, int pattern, int beat, int col) {
		OscMessage myOscMessage = new OscMessage("/setValue");
		myOscMessage.add((int) track);
		myOscMessage.add((int) value);
		myOscMessage.add((int) pattern);
		myOscMessage.add((int) beat);
		myOscMessage.add((int) col);
		oscP5.send(myOscMessage, myRemoteLocation);
	}

	public void setTempo(int tempo) {
		OscMessage myOscMessage = new OscMessage("/setTempo");
		myOscMessage.add((int) tempo);
		oscP5.send(myOscMessage, myRemoteLocation);
	}

	public static void main(String[] args) {
		PApplet.main(new String[] { "Window" });
	}
}
